<!----------------------------------------------------------------------------------------------------------------------
  -- RedisOptions
  --------------------------------------------------------------------------------------------------------------------->

<template>
    <BFormRow>
        <BCol cols="6">
            <BFormGroup
                id="env-hostname"
                description="The hostname of the redis server. Required."
                label="Hostname"
                label-for="hostname-input"
            >
                <template #description>
                    The hostname of the redis server. <b class="text-danger">Required.</b>
                </template>
                <BFormInput
                    id="hostname-input"
                    v-model="options.host"
                    trim
                    required
                    :disabled="props.disabled"
                />
            </BFormGroup>
        </BCol>
        <BCol>
            <BFormGroup
                id="env-port"
                description="The port of the redis server. Default is 6379"
                label="Port"
                label-for="port-input"
            >
                <template #description>
                    Redis server port (default: <code>6379</code>).
                </template>
                <BFormInput
                    id="port-input"
                    v-model="options.port"
                    min="0"
                    step="1"
                    type="number"
                    placeholder="6379"
                    number
                    :disabled="props.disabled"
                />
            </BFormGroup>
        </BCol>
        <BCol>
            <BFormGroup
                id="env-db"
                description="The db index of the redis server. Default is 0"
                label="DB Index"
                label-for="db-input"
            >
                <template #description>
                    Redis db index (default: <code>0</code>).
                </template>
                <BFormInput
                    id="db-input"
                    v-model="options.db"
                    min="0"
                    step="1"
                    type="number"
                    placeholder="0"
                    number
                    :disabled="props.disabled"
                />
            </BFormGroup>
        </BCol>
    </BFormRow>
    <BFormRow>
        <BCol>
            <BFormGroup
                id="env-username"
                description="The username to log into the redis server. (Optional)"
                label="Username"
                label-for="username-input"
            >
                <BFormInput
                    id="username-input"
                    v-model="options.username"
                    trim
                    :disabled="props.disabled"
                />
            </BFormGroup>
        </BCol>
        <BCol>
            <BFormGroup
                id="env-password"
                description="The password to log into the redis server. (Optional)"
                label-for="password-input"
            >
                <template #label>
                    Password
                </template>
                <BFormInput
                    id="password-input"
                    v-model="options.password"
                    :type="passwordVisible ? 'text' : 'password'"
                    trim
                    required
                    style="padding-right: 34px"
                    :disabled="props.disabled"
                />
                <span
                    class="text-muted password-btn"
                    @click.stop.prevent="passwordVisible = !passwordVisible"
                >
                    <Fa :icon="!passwordVisible ? 'eye' : 'eye-slash'" fixed-width />
                </span>
            </BFormGroup>
        </BCol>
    </BFormRow>
</template>

<!--------------------------------------------------------------------------------------------------------------------->

<style scoped lang="scss">
    #env-password {
        position: relative;
    }

    .password-btn {
        cursor: pointer;
        height: 32px;
        width: 32px;
        position: absolute;
        right: 10px;
        top: 32px;
        line-height: 32px;
        text-align: center;
    }
</style>

<!--------------------------------------------------------------------------------------------------------------------->

<script setup lang="ts">
    import { ref } from 'vue';

    // Models
    import { RedisOptions } from '../../../lib/models/backends/redis';

    //------------------------------------------------------------------------------------------------------------------
    // Component Definition
    //------------------------------------------------------------------------------------------------------------------

    interface Props
    {
        disabled ?: boolean
    }

    const props = withDefaults(defineProps<Props>(), {
        disabled: false,
    });

    //------------------------------------------------------------------------------------------------------------------
    // Refs
    //------------------------------------------------------------------------------------------------------------------

    const passwordVisible = ref(false);
    const options = defineModel<RedisOptions>({ required: true });
</script>

<!--------------------------------------------------------------------------------------------------------------------->
